package edu.columbia.logging.file;
/*
 * main class that invokes the parser, other objects and writer that creates the xml files for plotting
 * author shruti
 */

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.logging.Logger;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class ChatParserANDWriter {

	private static void printUsage() {
		System.out
				.println("java -jar Chatparse.jar -f <outputFileName1> <outputFileName2> <outputFileName3> <outputFileName4>");
		
	}

	static String fileName_by_user = null;

	static String fileName_by_date = null;

	static String fileName_by_time = null;

	static String fileName_by_bytes = null;

	public static SortedMap chat_data_by_date = new TreeMap();

	public static SortedMap chat_data_by_user = new TreeMap();

	public static SortedMap chatUserObject = new TreeMap();

	public static String userI = "";

	public static HashMap user_bytes = new HashMap();

	public static void main(String[] args) throws Exception {
		String classPath = System.getProperty("java.class.path", ".");
		System.out.println("This is classpath: " + classPath);
		try {

			if (args[0].equals("-f")) {
				fileName_by_user = args[1];
				fileName_by_date = args[2];
				fileName_by_time = args[3];
				fileName_by_bytes = args[4];
			} else {
				printUsage();

				return;
			}
		} catch (Exception ex) {
			printUsage();

			return;
		}
		System.out
				.println("Please unzip the contents of this zip file into the folder where your Sametime 7.5 ChatTranscripts are located");
		System.out
				.println("For example, there should be 2 files under C:\\Documents and Settings\\Administrator\\SametimeTranscripts\\Chatparse.bat and");
		System.out
				.println("C:\\Documents and Settings\\Administrator\\SametimeTranscripts\\Chatparse.jar");
		System.out.println("Then run the bat file.");
		System.out.println("THANKS!!!");

		loadChat();

		System.out.println("DONE");
		System.out
				.println(userI
						+ ", We have now analysed your chat logs. Please go to your Chat Transcript directory and look for a 'CHATDATA' directory");
		System.out
				.println("Please zip that and folder and send it to Shruti Gandhi at gandhish@us.ibm.com.");
		System.out.println("THANKS!!!");
	}

	public static void preload_totaldailychat() {
		int monthdates = 20070101;

		for (int i = 0; i < 31; i++) {
			if (chat_data_by_date.get(monthdates + "") == null)
				chat_data_by_date.put(monthdates + "", null);
			monthdates++;
		}
		monthdates = 20070201;
		for (int i = 0; i < 29; i++) {
			if (chat_data_by_date.get(monthdates + "") == null)
				chat_data_by_date.put(monthdates + "", null);
			monthdates++;
		}
		monthdates = 20070301;
		for (int i = 0; i < 31; i++) {
			if (chat_data_by_date.get(monthdates + "") == null)
				chat_data_by_date.put(monthdates + "", null);
			monthdates++;
		}
		monthdates = 20070401;
		for (int i = 0; i < 30; i++) {
			if (chat_data_by_date.get(monthdates + "") == null)
				chat_data_by_date.put(monthdates + "", null);
			monthdates++;
		}

	}

	private static String m_RootPath = null;

	private static File personFolderFile = null;

	static Hashtable countdata = new Hashtable();

	public static int totalchatwithuser = 0;

	public static int totalchatnumber = 0;

	public static HashMap totaldailychat = new HashMap();

	public static HashMap totaluserchat = new HashMap();

	public static HashMap storeuserchattimeinfo = new HashMap();

	public static ArrayList chatdetailobjectlist = new ArrayList();

	// loading transcripts
	public static void loadChat() {
		if (m_RootPath == null) {
			// me
			m_RootPath = System.getProperty("user.home") + File.separator
					+ "SametimeTranscripts";
			// others
			// m_RootPath = ".";

			System.out.println("This is where the chats are: " + m_RootPath);
		}
		try {

			loadFolders();
			FilePersonHistory[] ich = (FilePersonHistory[]) getChatPersons();

			for (int j = 0; j < ich.length; j++) {

				if (ich[j].getContactID().indexOf("multi-way") == -1) {
					ich[j].loadTranscripts();
				}
			}
			// me - number 45
			// ich[46].loadTranscripts();
			// System.out.println("ich.length: " + ich.length);
			totalchatwithuser = 0;
			for (Iterator it = totaluserchat.keySet().iterator(); it.hasNext();) {
				String values = (String) it.next();
				totalchatwithuser = totalchatwithuser
						+ ((Integer) totaluserchat.get(values)).intValue();
				
			}
			// System.out.println("ich.length: " + totaluserchat.size());
			OutputStream out = null;
			DocumentBuilder docBuilder;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			docBuilder = dbf.newDocumentBuilder();
			out = new BufferedOutputStream(new FileOutputStream(
					fileName_by_user));
			TransformerFactory factory = TransformerFactory.newInstance();
			Transformer transformer = factory.newTransformer();
			transformer.setOutputProperty(OutputKeys.INDENT, "yes"); //$NON-NLS-1$
			transformer.setOutputProperty(OutputKeys.METHOD, "xml"); //$NON-NLS-1$
			transformer.setOutputProperty(
					"{http://xml.apache.org/xslt}indent-amount", "4");
			Document doc = docBuilder.newDocument();
			Element chatdataparent;
			if (userI != "" && userI.length() > 0 && userI != null)
				chatdataparent = doc.createElement(userI);
			else
				chatdataparent = doc.createElement("ChatData");
			doc.appendChild(chatdataparent);

			int g = 1;
			for (Iterator iter = chat_data_by_user.entrySet().iterator(); iter
					.hasNext();) {

				SortedMap dateANDcount_list = null;
				Map.Entry e = (Map.Entry) iter.next();
				String userid = e.getKey().toString();

				Element user = doc.createElement("user");
				chatdataparent.appendChild(user);

				Attr user_id = doc.createAttribute("id");
				user_id.setValue(g + "");
				user.setAttributeNode(user_id);
				g++;
				dateANDcount_list = (SortedMap) chat_data_by_user.get(userid);

				Attr user_total = doc.createAttribute("total");
				Attr user_percent = doc.createAttribute("percent");
				Attr initiator = doc.createAttribute("initiator");
				Attr lastActivityTime = doc.createAttribute("lastActivityTime");
				Attr creationTime = doc.createAttribute("creationTime");

				if (totaluserchat.get(userid) == null) {
					user_total.setValue(0 + "");
					user_percent.setValue(0 + "");

				} else {
					user_total.setValue(totaluserchat.get(userid).toString());
					// System.out.println(userid+" totaluserchat.get(userid):
					// "+totaluserchat.get(userid) +" "+(totalchatwithuser));
					// System.out.println("totaluserchat.get(userid):
					// "+((Integer)totaluserchat.get(userid)).intValue()/totalchatwithuser
					// +" "+(totalchatwithuser));
					if (totalchatwithuser != 0
							&& totaluserchat.get(userid) != null
							&& ((Integer) totaluserchat.get(userid)) != new Integer(
									0)) {
						double percent_chat_with_this_user = roundDBL(((double) ((double) ((double) (((Integer) totaluserchat
								.get(userid)).doubleValue() * 100)) / (totalchatwithuser)) * 100) / 30);
						user_percent.setValue(percent_chat_with_this_user + "");
					}
					// System.out.println(dateANDcount_list.size() + ": " +
					// dateANDcount_list);

				}

				ChatUserInfo cui = (ChatUserInfo) chatUserObject.get(userid);
				if (cui.creationTime != null)
					creationTime.setValue(cui.creationTime.toGMTString());
				else
					creationTime.setValue("00:00:00");
				if (cui.initiator != null)
					initiator.setValue(cui.initiator);
				else
					initiator.setValue("unknown");
				if (cui.lastActivityTime != null)
					lastActivityTime.setValue(cui.lastActivityTime
							.toGMTString());
				else
					lastActivityTime.setValue("00:00:00");
				// set xml values
				user.setAttributeNode(user_total);
				user.setAttributeNode(user_percent);
				user.setAttributeNode(creationTime);
				user.setAttributeNode(initiator);
				user.setAttributeNode(lastActivityTime);

				if (dateANDcount_list != null) {
					if (dateANDcount_list.size() >= 1) {

						for (Iterator countiter = dateANDcount_list.entrySet()
								.iterator(); countiter.hasNext();) {
							Map.Entry entry = (Map.Entry) countiter.next();
							String dte = entry.getKey().toString();
							Integer count = (Integer) dateANDcount_list
									.get(dte);
							Element date = doc.createElement("date");
							user.appendChild(date);
							Attr chatdate = doc.createAttribute("chatdate");
							chatdate.setValue(dte);
							date.setAttributeNode(chatdate);
							Node txtNode = doc.createTextNode(count.toString());
							date.appendChild(txtNode);

						}
					}
				}

			}
			Source input = new DOMSource(doc);
			Result output = new StreamResult(out);
			transformer.transform(input, output);
			out.flush();
			out.close();

			preload_totaldailychat();

			chatdatefile();
			chatobjectfile();
			chatbybytesfile();
		} catch (Exception ex) {
			System.err.println("Exception occurred while running writer" + ex);
			ex.printStackTrace();
		}
	}

	public static String byteArrayToHexString(byte[] b) {
		StringBuffer sb = new StringBuffer(b.length * 2);
		for (int i = 0; i < b.length; i++) {
			int v = b[i] & 0xff;
			if (v < 16) {
				sb.append('0');
			}
			sb.append(Integer.toHexString(v));
		}
		return sb.toString().toUpperCase();
	}

	public static void chatdatefile() {
		try {
			OutputStream out = null;
			DocumentBuilder docBuilder;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

			docBuilder = dbf.newDocumentBuilder();

			out = new BufferedOutputStream(new FileOutputStream(
					fileName_by_date));
			TransformerFactory factory = TransformerFactory.newInstance();
			Transformer transformer = factory.newTransformer();
			transformer.setOutputProperty(OutputKeys.INDENT, "yes"); //$NON-NLS-1$
			transformer.setOutputProperty(OutputKeys.METHOD, "xml"); //$NON-NLS-1$
			transformer.setOutputProperty(
					"{http://xml.apache.org/xslt}indent-amount", "4");
			Document doc = docBuilder.newDocument();
			Element chatdataparent;
			if (userI != "" && userI.length() > 0 && userI != null)
				chatdataparent = doc.createElement(userI);
			else
				chatdataparent = doc.createElement("ChatData");
			doc.appendChild(chatdataparent);

			for (Iterator iter = chat_data_by_date.entrySet().iterator(); iter
					.hasNext();) {

				SortedMap userANDcount_list = null;
				Map.Entry e = (Map.Entry) iter.next();
				String date = e.getKey().toString();

				Element user = doc.createElement("date");
				chatdataparent.appendChild(user);

				Attr chatdate = doc.createAttribute("chatdate");
				chatdate.setValue(date);
				user.setAttributeNode(chatdate);

				Attr user_total = doc.createAttribute("total");

				if (totaldailychat.get(date) == null) {
					user_total.setValue(0 + "");

				} else {
					user_total.setValue(totaldailychat.get(date).toString());
					userANDcount_list = (SortedMap) chat_data_by_date.get(date);
				}
				user.setAttributeNode(user_total);
				// user.setAttributeNode( user_percent );

				if (userANDcount_list != null) {
					if (userANDcount_list.size() >= 1) {

						int u = 1;
						for (Iterator countiter = userANDcount_list.entrySet()
								.iterator(); countiter.hasNext();) {
							Map.Entry entry = (Map.Entry) countiter.next();
							String userid = entry.getKey().toString();
							Integer count = (Integer) userANDcount_list
									.get(userid);
							Element usertag = doc.createElement("user");
							user.appendChild(usertag);
							Attr uid = doc.createAttribute("id");
							// uid.setValue(userid );
							uid.setValue(u + "");
							usertag.setAttributeNode(uid);
							Node txtNode = doc.createTextNode(count.toString());
							usertag.appendChild(txtNode);
							u++;
						}
					}
				}

			}
			Source input = new DOMSource(doc);
			Result output = new StreamResult(out);
			transformer.transform(input, output);
			out.flush();
			out.close();

		} catch (ParserConfigurationException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void chatobjectfile() {
		try {
			OutputStream out = null;
			DocumentBuilder docBuilder;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

			docBuilder = dbf.newDocumentBuilder();

			out = new BufferedOutputStream(new FileOutputStream(
					fileName_by_time));

			HashMap store_time_tally = new HashMap();
			System.out.println("chatdetailobjectlist: "
					+ chatdetailobjectlist.size());
			for (int iter = 0; iter < chatdetailobjectlist.size(); iter++) {
				ChatDetailObject timeobject = (ChatDetailObject) chatdetailobjectlist
						.get(iter);
				int time = timeobject.length;

				Integer dis_tally = (Integer) store_time_tally.get(new Integer(
						time));
				if (dis_tally == null)
					store_time_tally.put(new Integer(time), new Integer(1));
				else {
					int tally = dis_tally.intValue() + 1;
					store_time_tally.put(new Integer(time), new Integer(tally));
				}
			}

			// System.out.println(""+ store_time_tally.size());

			TransformerFactory factory = TransformerFactory.newInstance();
			Transformer transformer = factory.newTransformer();
			transformer.setOutputProperty(OutputKeys.INDENT, "yes"); //$NON-NLS-1$
			transformer.setOutputProperty(OutputKeys.METHOD, "xml"); //$NON-NLS-1$
			transformer.setOutputProperty(
					"{http://xml.apache.org/xslt}indent-amount", "4");
			Document doc = docBuilder.newDocument();
			Element chatdataparent;
			if (userI != "" && userI.length() > 0 && userI != null)
				chatdataparent = doc.createElement(userI);
			else
				chatdataparent = doc.createElement("ChatData");
			doc.appendChild(chatdataparent);

			Map sortedMap = ValueSortMap.sortMapByValue(store_time_tally, true);
			for (Iterator iter = sortedMap.entrySet().iterator(); iter
					.hasNext();) {
				Map.Entry e = (Map.Entry) iter.next();
				Integer length = (Integer) e.getKey();
				System.out.println("" + length + "--" + sortedMap.get(length));
				System.out.println("-------------");
				Element tally = doc.createElement("tally");
				chatdataparent.appendChild(tally);

				Attr period = doc.createAttribute("length");
				period.setValue(length + "");
				tally.setAttributeNode(period);

				Attr dist = doc.createAttribute("distribution");
				dist.setValue(store_time_tally.get(length) + "");
				tally.setAttributeNode(dist);

				Node txtNode = doc.createTextNode("ter");
				tally.appendChild(txtNode);
			}
			/*
			 * for (Iterator iter=store_time_tally.entrySet().iterator();
			 * iter.hasNext(); ) { Map.Entry e = (Map.Entry) iter.next();
			 * Integer length = (Integer) e.getKey(); // System.out.println(""+
			 * length+ "--"+ store_time_tally.get(length));
			 * 
			 * Element tally = doc.createElement("tally");
			 * chatdataparent.appendChild( tally );
			 * 
			 * Attr period = doc.createAttribute( "length" );
			 * period.setValue(length+"" ); tally.setAttributeNode( period );
			 * 
			 * Attr dist = doc.createAttribute( "distribution" );
			 * dist.setValue(store_time_tally.get(length)+"" );
			 * tally.setAttributeNode(dist );
			 * 
			 * Node txtNode = doc.createTextNode( "data" ); tally.appendChild(
			 * txtNode); }
			 */

			Source input = new DOMSource(doc);
			Result output = new StreamResult(out);
			transformer.transform(input, output);
			out.flush();
			out.close();

		} catch (ParserConfigurationException e) {
			System.out.println("ERROR: " + e.toString());
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			System.out.println("ERROR: " + e.toString());
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerException e) {
			System.out.println("ERROR: " + e.toString());
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("ERROR: " + e.toString());
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void chatbybytesfile() {
		try {
			OutputStream out = null;
			DocumentBuilder docBuilder;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

			docBuilder = dbf.newDocumentBuilder();

			out = new BufferedOutputStream(new FileOutputStream(
					fileName_by_bytes));
			TransformerFactory factory = TransformerFactory.newInstance();
			Transformer transformer = factory.newTransformer();
			transformer.setOutputProperty(OutputKeys.INDENT, "yes");
			transformer.setOutputProperty(OutputKeys.METHOD, "xml");
			transformer.setOutputProperty(
					"{http://xml.apache.org/xslt}indent-amount", "4");
			Document doc = docBuilder.newDocument();
			Element chatdataparent;
			if (userI != "" && userI.length() > 0 && userI != null)
				chatdataparent = doc.createElement(userI);
			else
				chatdataparent = doc.createElement("ChatData");
			doc.appendChild(chatdataparent);

			int usr = 0;
			Map sortedMap = ValueSortMap.sortMapByValue(user_bytes, true);
			for (Iterator iter = sortedMap.entrySet().iterator(); iter
					.hasNext();) {
				Map.Entry e = (Map.Entry) iter.next();
				String username = (String) e.getKey();
				// System.out.println(""+ length+ "--"+ sortedMap.get(length));
				// System.out.println("-------------");
				Element tally = doc.createElement("user");
				chatdataparent.appendChild(tally);

				Attr period = doc.createAttribute("name");
				period.setValue(usr + "");
				tally.setAttributeNode(period);

				Attr dist = doc.createAttribute("chatlength_in_bytes");
				dist.setValue(user_bytes.get(username) + "");
				tally.setAttributeNode(dist);

				Node txtNode = doc.createTextNode("data");
				tally.appendChild(txtNode);
				usr++;
			}
			/*
			 * for (Iterator iter=store_time_tally.entrySet().iterator();
			 * iter.hasNext(); ) { Map.Entry e = (Map.Entry) iter.next();
			 * Integer length = (Integer) e.getKey(); System.out.println(""+
			 * length+ "--"+ store_time_tally.get(length));
			 * 
			 * Element tally = doc.createElement("tally");
			 * chatdataparent.appendChild( tally );
			 * 
			 * Attr period = doc.createAttribute( "length" );
			 * period.setValue(length+"" ); tally.setAttributeNode( period );
			 * 
			 * Attr dist = doc.createAttribute( "distribution" );
			 * dist.setValue(store_time_tally.get(length)+"" );
			 * tally.setAttributeNode(dist );
			 * 
			 * Node txtNode = doc.createTextNode( "ter" ); tally.appendChild(
			 * txtNode); }
			 */

			Source input = new DOMSource(doc);
			Result output = new StreamResult(out);
			transformer.transform(input, output);
			out.flush();
			out.close();

		} catch (ParserConfigurationException e) {
			System.out.println("ERROR: " + e.toString());
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			System.out.println("ERROR: " + e.toString());
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TransformerException e) {
			System.out.println("ERROR: " + e.toString());
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("ERROR: " + e.toString());
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static double roundDBL(double targetDBL) {
		int decimalPlace = 2;
		// System.out.println("targetDBL: "+targetDBL);
		BigDecimal bd = new BigDecimal(targetDBL);
		bd = bd.setScale(decimalPlace, BigDecimal.ROUND_UP);

		return (bd.doubleValue());
	}

	// get person folder file
	private static File getPersonFolderFile() {
		if (personFolderFile == null) {
			personFolderFile = new File(m_RootPath, "personfolders.xml");
		}
		return personFolderFile;
	}

	private static List personFolders = Collections
			.synchronizedList(new ArrayList());

	public static void loadFolders() {
		List items = null;
		if (items == null) {
			try {
				File fLogFolder = new File(m_RootPath);
				System.out.println("Current dir : "
						+ fLogFolder.getCanonicalPath());

				if (fLogFolder.exists()) {
					FilePersonHistory[] perhists = getChatHistoriesPath(fLogFolder
							.getAbsolutePath());
					System.out
							.println("Chat folders found: " + perhists.length);
					if ((perhists != null) && (perhists.length > 0)) {
						personFolders = Collections
								.synchronizedList(new ArrayList());
						for (int i = 0; i < perhists.length; i++) {
							String strFolderName = perhists[i].getFolder()
									.getName();
							FolderLogPerson flp = new FolderLogPerson();
							flp.setContactId(perhists[i].getContactID());
							flp.setCommunityId(perhists[i].getCommunityID());
							flp.setDisplayName(perhists[i].getDisplayName());
							flp.setIsExternal(perhists[i].isExternalID());
							flp.setFolderName(strFolderName);
							personFolders.add(flp);
						}

					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private static FilePersonHistory[] getChatHistoriesPath(String path) {
		StringBuffer pathBuffer = new StringBuffer();
		pathBuffer.append(path);
		pathBuffer.append(File.separator);

		File chatHistoryDir = new File(pathBuffer.toString());
		if (chatHistoryDir.exists()) {
			ArrayList histories = new ArrayList();
			File[] dirs = chatHistoryDir.listFiles();
			for (int i = 0; i < dirs.length; i++) {
				if (dirs[i].isDirectory() && dirs[i].canRead()) {
					String name = dirs[i].getName();
					IChatPersonHistory history = getChatHistoryForPath(path,
							name);
					if (history != null) {
						histories.add(history);
					}
				}
			}
			pathBuffer = null;
			return (FilePersonHistory[]) histories
					.toArray(new FilePersonHistory[0]);
		}
		pathBuffer = null;
		return null;
	}

	private static Logger logger = Logger.getLogger(FilePersonHistory.class
			.getPackage().getName());

	private static FilePersonHistory getChatHistoryForPath(String path,
			String contactId) {
		FilePersonHistory history = null;
		StringBuffer pathBuffer = new StringBuffer();
		pathBuffer.append(path);
		pathBuffer.append(File.separator);
		pathBuffer.append(contactId);
		pathBuffer.append(File.separator);

		File personDir = new File(pathBuffer.toString());
		if (personDir.exists()) {
			String[] dirList = personDir.list();
			if ((dirList != null) && (dirList.length > 0)) {
				history = new FilePersonHistory(EncoderDecoder
						.decodeOld(contactId), false, null, null, null,
						personDir);
				if (!history.isValid()) {
					history = null;
				}
			}
		}
		pathBuffer = null;
		return history;
	}

	public static IChatPersonHistory[] getChatPersons() {
		ArrayList items = new ArrayList();
		String strPath = getPersonFolderFile().getParent();
		synchronized (personFolders) {
			for (Iterator iter = personFolders.iterator(); iter.hasNext();) {
				FolderLogPerson flp = (FolderLogPerson) iter.next();
				File fPath = new File(strPath, flp.getFolderName());
				FilePersonHistory fph = new FilePersonHistory(flp
						.getContactId(), flp.isExternal(), flp.getGWCommId(),
						flp.getCommunityId(), flp.getDisplayName(), fPath);
				if (fph != null) {
					items.add(fph);
				}
			}
		}

		return (FilePersonHistory[]) items.toArray(new FilePersonHistory[0]);
	}

}
