
package edu.columbia.logging.file;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.Attributes;

public class FolderLogPerson {
	public static final String FLP_ELEM_NAME = "folder";
	
	private static final String FLP_ELEM_ID = "id";
	private static final String FLP_ELEM_EXT = "isExternal";
	private static final String FLP_ELEM_COMM = "communityId";
	private static final String FLP_ELEM_DN = "displayName";
	private static final String FLP_ELEM_FP = "folderPath";
	private static final String FLP_ELEM_GWCOMM = "gwComm";
	
	private String itsContactId;
	private boolean itsIsExternal;
	private String itsCommunityId;
	private String itsDisplayName;
	private String itsFolderName;
	private String itsGWCommId;
	/**
	 * @return the itsCommunityId
	 */
	public String getCommunityId() {
		return itsCommunityId;
	}
	/**
	 * @param communityID the itsCommunityId to set
	 */
	public void setCommunityId(String communityId) {
		this.itsCommunityId = communityId;
	}
	/**
	 * @return the itsCommunityId
	 */
	public String getGWCommId() {
		return itsGWCommId;
	}
	/**
	 * @param GWCommID the itsGWCommId to set
	 */
	public void setGWCommId(String GWCommId) {
		this.itsGWCommId = GWCommId;
	}
	/**
	 * @return the itsContactId
	 */
	public String getContactId() {
		return itsContactId;
	}
	/**
	 * @param contactId the itsContactId to set
	 */
	public void setContactId(String contactId) {
		this.itsContactId = contactId;
	}
	/**
	 * @return the itsDisplayName
	 */
	public String getDisplayName() {
		return itsDisplayName;
	}
	/**
	 * @param displayName the itsDisplayName to set
	 */
	public void setDisplayName(String displayName) {
		this.itsDisplayName = displayName;
	}
	/**
	 * @return the itsFolderPath
	 */
	public String getFolderName() {
		return itsFolderName;
	}
	/**
	 * @param folderName the itsFolderName to set
	 */
	public void setFolderName(String folderName) {
		this.itsFolderName = folderName;
	}
	/**
	 * @return the itsIsExternal
	 */
	public boolean isExternal() {
		return itsIsExternal;
	}
	/**
	 * @param isExternal the itsIsExternal to set
	 */
	public void setIsExternal(boolean isExternal) {
		this.itsIsExternal = isExternal;
	}
	
	public Element createElement(Document doc) {
		Element elem;
		if (doc != null) {
			elem = doc.createElement(FLP_ELEM_NAME);

			Attr attr = doc.createAttribute(FLP_ELEM_ID);
			elem.setAttributeNode(attr);
			attr.setValue(getContactId());

			attr = doc.createAttribute(FLP_ELEM_EXT);
			elem.setAttributeNode(attr);
			attr.setValue(Boolean.toString(isExternal()));

			attr = doc.createAttribute(FLP_ELEM_COMM);
			elem.setAttributeNode(attr);
			attr.setValue(getCommunityId());

			attr = doc.createAttribute(FLP_ELEM_DN);
			elem.setAttributeNode(attr);
			attr.setValue(getDisplayName());		

			attr = doc.createAttribute(FLP_ELEM_FP);
			elem.setAttributeNode(attr);
			attr.setValue(getFolderName());

			if (getGWCommId() != null) {
				attr = doc.createAttribute(FLP_ELEM_GWCOMM);
				elem.setAttributeNode(attr);
				attr.setValue(getGWCommId());
			}
		} else {
			elem = null;
		}
		return elem;
	}

	public static FolderLogPerson createFromElement(Attributes attrs) {
		FolderLogPerson flp;
		if (attrs != null) {
			flp = new FolderLogPerson();
			flp.setContactId(attrs.getValue(FLP_ELEM_ID));
			String s = attrs.getValue(FLP_ELEM_EXT);
			if ((s != null) && s.equals("true"))
				flp.setIsExternal(true);
			else
				flp.setIsExternal(false);
			flp.setCommunityId(attrs.getValue(FLP_ELEM_COMM));
			flp.setDisplayName(attrs.getValue(FLP_ELEM_DN));
			flp.setFolderName(attrs.getValue(FLP_ELEM_FP));
			flp.setGWCommId(attrs.getValue(FLP_ELEM_GWCOMM));
		} else {
			flp = null;
		}
		return flp;
	}
}
