package edu.columbia.logging.file;



/**
 * Chat history with a single person.
 *
 */
public interface IChatPersonHistory {

	/**
	 * Get the contact id for this person
	 * @return String
	 */
	public String getContactID();
	
	/**
	 * Return whether the contact ID is external
	 * @return true if external
	 */
	public boolean isExternalID();
	
	/**
	 * Get the community through which these conversations were had
	 */
	public String getCommunityID();
	
	/**
	 * @return the contact ID display name
	 */
	public String getDisplayName();

}
